(**************************************************************************)
(*                                                                        *)
(*                     TRX: A Web Transaction Manager                     *)
(*                                                                        *)
(*                      Avik Chaudhuri & Grard Huet                      *)
(*                                                                        *)
(* 2002 Institut National de Recherche en Informatique et en Automatique *)
(**************************************************************************)

(* Signature of the structure describing an application *)

open TyTr;

module type APP = 
sig

exception AppError of string;

(*-- memory type *)	
type stt = 'a;

(*-- output type *)
type oup = 'b;

(*-- input type *)
type inlist = 'c;
		
(*-- initial state *)
value initstt : stt;

(*-- initial display with user preferences *)
value initstr : user -> string;

(*-- initial submit method if POST *)
value initsub : bool;
		
(*-- jump function,
recalls output and input options for some earlier transaction *)
value jmf : idstamp -> stt -> (oup * inlist);

(*-- computation function,
     takes current memory and input 
     to produce output, new input options and new memory *)
value cof : idstamp -> stt -> arglist -> (oup * inlist * stt);

(*-- printing function,
prints output as required by the application *)
value prf : oup -> inlist -> string;
		
end;

