(**************************************************************************)
(*                                                                        *)
(*                     TRX: A Web Transaction Manager                     *)
(*                                                                        *)
(*                      Avik Chaudhuri & Grard Huet                      *)
(*                                                                        *)
(* 2002 Institut National de Recherche en Informatique et en Automatique *)
(**************************************************************************)

(* Defining the basic types for transactions
and high level transaction processing functions *)
	
value version = "1.3"
and version_date = "2002-7-23";

type service = int 
and user = int
and session = int
and transaction = int

and idstamp = (service * user * session * transaction)

(* --- input for transaction as a (name,value)-list  *)
and arglist = list (string * string);

value ((machip:string),(frport:int),
       cgiex,(svctab:Hashtbl.t int (string*int*string))) = 
  let fin = open_in "tabsvc" in
  let iv = input_value fin in 
  do { close_in fin; iv };

(* --- header and tailer *)
value hdtrx s c w n b = 
	("Content-type:text/html\n\n" ^
	"<HTML><HEAD><TITLE>TRX</TITLE></HEAD>
	<BODY BGCOLOR=\"White\"><CENTER>
	<FORM ACTION=\""^cgiex^
	(if b then "frontinit\" METHOD=\"POST\">"
	else "front\" METHOD=\"GET\">")^
	"<TABLE BGCOLOR=\"ANTIQUEWHITE\">
	<TR><TD><P><B> Running on TRX "^version^" </B></P></TD>
	<TD> Service# <B>"^(string_of_int s)^
	"</B>, User# <B>"^(string_of_int c)^
	"</B>, Session# <B>"^(string_of_int w)^
	"</B>, Transaction# <B>"^(string_of_int n)^
	"</B> <TD> 
	<INPUT TYPE=\"radio\" NAME=\"jop\" VALUE=\"next\" CHECKED>Next
        <INPUT TYPE=\"radio\" NAME=\"jop\" VALUE=\"jump\">Jump
	<INPUT TYPE=\"text\" NAME=\"trxno\"> </TD><TD> 
	<A HREF=\""^cgiex^"front?trxno=&jop=quit"^
	"&service=1&user=0&session=0&transaction=0\">
	<FONT COLOR=\"BLACK\"><B>Quit</B></FONT></A> </TD></TR></TABLE><HR>
	")
	
and tltrx s c w n = 
	("<INPUT TYPE=\"hidden\" NAME=\"service\" 
	VALUE=\""^(string_of_int s)^"\">" ^
	"<INPUT TYPE=\"hidden\" NAME=\"user\" 
	VALUE=\""^(string_of_int c)^"\">" ^
	"<INPUT TYPE=\"hidden\" NAME=\"session\" 
	VALUE=\""^(string_of_int w)^"\">" ^
	"<INPUT TYPE=\"hidden\" NAME=\"transaction\" 
	VALUE=\""^(string_of_int n)^"\">" ^
	"</FORM></BODY></HTML>");

(* -- default page *)
value deftrx' =
	"<HTML><HEAD>
	<TITLE>TRX</TITLE>
	</HEAD>
	<BODY BGCOLOR=\"White\"><CENTER>
	<TABLE BGCOLOR=\"ANTIQUEWHITE\" BORDER=\"2\"; CELLPADDING=\"10%\" WIDTH=\"100%\">
	<TR><TD><CENTER><FONT COLOR=\"Red\">
	<P><B>TRX: a Web TRansaXion manager</B></P>
	<P><B>Avik Chaudhuri &amp; G&eacute;rard Huet</B></P>
	<P><B>Version "^version^" ("^version_date^")</B></P></FONT></TD></TR>
	</TABLE>
	<HR><BR>
	<B>TRX currently supports the following applications</B><BR>
	<TABLE><TR><TD>FUN</TD><TD>guessing game</TD><TD>#1</TD></TR>
	<TR><TD>STRED</TD><TD>structural editor</TD><TD>#4</TD></TR></TABLE>
	<FORM ACTION=\""^cgiex^"front\" METHOD=\"GET\">
	<TABLE><TR><TD>
	<FONT COLOR=\"Blue\">SERVICE</FONT></TD><TD>
	<INPUT TYPE=\"text\" NAME=\"service\" VALUE=\"1\"></TD></TR>
	<TR><TD>		
	<FONT COLOR=\"Blue\">USER</FONT></TD><TD>
	<INPUT TYPE=\"text\" NAME=\"user\" VALUE=\"1\"></TD></TR>
	<TR><TD>
	<FONT COLOR=\"Blue\">SESSION</FONT></TD><TD>
	<INPUT TYPE=\"radio\" NAME=\"session\" VALUE=\"0\" CHECKED>
	<FONT COLOR=\"Blue\">New</FONT>
	<INPUT TYPE=\"radio\" NAME=\"session\" VALUE=\"-1\">
	<FONT COLOR=\"Blue\">Old</FONT>
	<INPUT TYPE=\"text\" NAME=\"w\"></TD></TR>
	</TABLE>
	<INPUT TYPE=\"hidden\" NAME=\"transaction\" VALUE=\"1\">	
	<TABLE><TR><TD>
	<INPUT TYPE=\"submit\" VALUE=\"TRX\"></TD></TR></TABLE></FORM>
	</BODY></HTML>";

value deftrx = 
	"Content-type:text/html\n\n"^
	deftrx';

(* -- error printing *)
value prerr s = 
	"<FONT COLOR=\"RED\"><B>ERROR: </B><I>"^s^"</I></FONT>";

(*  -- frontend,
	parses request into transaction-id and function-call parameters *) 
(*	[ frend : Front.paf -> string -> (idstamp * arglist) ]  *)
value frend pars_fun req = pars_fun req;

(*  -- engine for transaction computation, 
	computes result, generates new input choices and memory updation  *)
(*	[ eng : App.cof -> (App.stt * arglist) 
				-> (App.oup * App.inlist * App.stt) ] *)
value eng comp_fun idtup vtrx_ce = 
	match vtrx_ce with
	[ (mem,alist) -> 
		comp_fun idtup mem alist ];

(*  -- travel function for jumping to some previous transaction,
	recalls the input choices for jump-to transaction *)
(*	[ trv : App.jmf -> (App.stt * arglist) 
				-> (App.oup * App.inlist) ] *)
value trv jump_fun idtup vtrx_ce = 
	match vtrx_ce with
	[ mem -> 
		jump_fun idtup mem ];

(*  -- backend,
	displays result of previous transaction, 
	and input choices for this transaction *)
(*	[ bkend : App.prf -> (App.oup * App.inlist) -> string ] *)
value bkend print_fun vce_tm = 
	match vce_tm with
	[ (res,olist) -> 
		print_fun res olist ];

